function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import WoodenTreeView, { ActionTypes } from './index';
const data = [{
  text: 'Parent 1',
  icon: 'fa fa-folder',
  nodes: [{
    text: 'Child 1',
    nodes: [{
      text: 'Grandchild 1'
    }, {
      text: 'Grandchild 2'
    }]
  }, {
    text: 'Child 2',
    nodes: [{
      text: 'Grandchild 1'
    }, {
      text: 'Grandchild 2'
    }]
  }]
}, {
  text: 'Parent 2',
  icon: 'fa fa-folder',
  nodes: [{
    text: 'Child 1'
  }]
}, {
  text: 'Parent 3',
  icon: 'fa fa-folder'
}, {
  text: 'Parent 4',
  icon: 'fa fa-folder'
}, {
  text: 'Parent 5',
  icon: 'fa fa-folder'
}];
const actionMapper = {
  [ActionTypes.EXPANDED]: WoodenTreeView.nodeExpanded,
  [ActionTypes.CHECKED]: WoodenTreeView.nodeChecked,
  [ActionTypes.DISABLED]: WoodenTreeView.nodeDisabled,
  [ActionTypes.SELECTED]: WoodenTreeView.nodeSelected,
  [ActionTypes.CHILD_NODES]: WoodenTreeView.nodeChildren,
  [ActionTypes.LOADING]: WoodenTreeView.nodeLoading
};

class TreeViewExample extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      tree: WoodenTreeView.convertHierarchicalTree(WoodenTreeView.initHierarchicalTree(data))
    });

    _defineProperty(this, "onDataChange", commands => {
      let tree = _objectSpread({}, this.state.tree);

      for (let i = 0; i < commands.length; i++) {
        const command = commands[i];
        let node = WoodenTreeView.nodeSelector(tree, command.nodeId);

        if (node !== null) {
          if (actionMapper.hasOwnProperty(command.type)) {
            node = actionMapper[command.type](node, command.value);
            tree = WoodenTreeView.nodeUpdater(tree, node);
          } else if (command.type === ActionTypes.ADD_NODES) {
            tree = WoodenTreeView.addNodes(tree, command.value);
          }
        }
      }

      this.setState({
        tree
      });
    });
  }

  render() {
    return React.createElement("div", {
      className: "App"
    }, React.createElement(WoodenTreeView, _extends({
      nodeIcon: "fa fa-file-o",
      data: this.state.tree,
      callbacks: {
        onDataChange: this.onDataChange
      }
    }, this.props)));
  }

}

export default TreeViewExample;