"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireWildcard(require("./index"));

var _actionMapper;

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var data = [{
  text: 'Parent 1',
  icon: 'fa fa-folder',
  nodes: [{
    text: 'Child 1',
    nodes: [{
      text: 'Grandchild 1'
    }, {
      text: 'Grandchild 2'
    }]
  }, {
    text: 'Child 2',
    nodes: [{
      text: 'Grandchild 1'
    }, {
      text: 'Grandchild 2'
    }]
  }]
}, {
  text: 'Parent 2',
  icon: 'fa fa-folder',
  nodes: [{
    text: 'Child 1'
  }]
}, {
  text: 'Parent 3',
  icon: 'fa fa-folder'
}, {
  text: 'Parent 4',
  icon: 'fa fa-folder'
}, {
  text: 'Parent 5',
  icon: 'fa fa-folder'
}];
var actionMapper = (_actionMapper = {}, _defineProperty(_actionMapper, _index.ActionTypes.EXPANDED, _index["default"].nodeExpanded), _defineProperty(_actionMapper, _index.ActionTypes.CHECKED, _index["default"].nodeChecked), _defineProperty(_actionMapper, _index.ActionTypes.DISABLED, _index["default"].nodeDisabled), _defineProperty(_actionMapper, _index.ActionTypes.SELECTED, _index["default"].nodeSelected), _defineProperty(_actionMapper, _index.ActionTypes.CHILD_NODES, _index["default"].nodeChildren), _defineProperty(_actionMapper, _index.ActionTypes.LOADING, _index["default"].nodeLoading), _actionMapper);

var TreeViewExample = /*#__PURE__*/function (_React$Component) {
  _inherits(TreeViewExample, _React$Component);

  function TreeViewExample() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TreeViewExample);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TreeViewExample)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      tree: _index["default"].convertHierarchicalTree(_index["default"].initHierarchicalTree(data))
    });

    _defineProperty(_assertThisInitialized(_this), "onDataChange", function (commands) {
      var tree = _objectSpread({}, _this.state.tree);

      for (var i = 0; i < commands.length; i++) {
        var command = commands[i];

        var node = _index["default"].nodeSelector(tree, command.nodeId);

        if (node !== null) {
          if (actionMapper.hasOwnProperty(command.type)) {
            node = actionMapper[command.type](node, command.value);
            tree = _index["default"].nodeUpdater(tree, node);
          } else if (command.type === _index.ActionTypes.ADD_NODES) {
            tree = _index["default"].addNodes(tree, command.value);
          }
        }
      }

      _this.setState({
        tree: tree
      });
    });

    return _this;
  }

  _createClass(TreeViewExample, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: "App"
      }, _react["default"].createElement(_index["default"], _extends({
        nodeIcon: "fa fa-file-o",
        data: this.state.tree,
        callbacks: {
          onDataChange: this.onDataChange
        }
      }, this.props)));
    }
  }]);

  return TreeViewExample;
}(_react["default"].Component);

var _default = TreeViewExample;
exports["default"] = _default;